﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Windows.UI.Xaml.Media
{
	/// <summary>
	/// Describes how content is positioned vertically in a container.
	/// </summary>
	public enum AlignmentY
    {
		/// <summary>
		/// The contents align toward the upper edge of the container.
		/// </summary>
		Top,

		/// <summary>
		/// The contents align toward the center of the container.
		/// </summary>
		Center,

		/// <summary>
		/// The contents align toward the lower edge of the container.
		/// </summary>
		Bottom
	}
}
